internalUpdateFDS <- function(){
  
  FDSImport <- fread("inst/extdata/FDSImport.csv")
  FDSLabel <- fread("inst/extdata/FDSLabel.csv")
  FDSValues <- fread("inst/extdata/FDSValues.csv")
  FDSStyles <- fread("inst/extdata/FDSStyles.csv")
  
  Styles <- split(FDSStyles, by = "style")
  
  
  addCurrentVersion <- function(){
    # Increasing this figure will require the user to use a newer version of the R-Tool
    templateId <- 15912
    currentTime <- 0
    currentTimeId <- as.character(templateId*1e5 + currentTime)
    data.table(content = "addCurrentVersion", row1 = 0, row2 = NA, col1 = 0, col2 = NA, textValue = "", numericValue = currentTimeId, sheet = "", withFX = NA, style = NA, sheetSource = NA)
  }
  
  addWorksheet <- function(sheet, rowMax, colMax){
    data.table(content = "addWorksheet", row1 = rowMax, row2 = NA, col1 = colMax, col2 = NA, textValue = "", numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
  }
  
  addText <- function(sheet, row, col, textValue){
    data.table(content = "addText", row1 = row, row2 = NA, col1 = col, col2 = NA, textValue = textValue, numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
  }
  
  addTextFromExcel <- function(sheet, row, col, sheetSource, rowSource, colSource){
    data.table(content = "addTextFromExcel", row1 = row, row2 = rowSource, col1 = col, col2 = colSource, textValue = NA, numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = sheetSource)
  }
  
  addNumericFromExcel <- function(sheet, row, col, sheetSource, rowSource, colSource, withFX){
    data.table(content = "addNumericFromExcel", row1 = row, row2 = rowSource, col1 = col, col2 = colSource, textValue = NA, numericValue = "", sheet = sheet, withFX = withFX, style = NA, sheetSource = sheetSource)
  }
  
  addNumericFromKeyword <- function(sheet, row, col, keyword, withFX){
    data.table(content = "addNumericFromKeyword", row1 = row, row2 = NA, col1 = col, col2 = NA, textValue = keyword, numericValue = "", sheet = sheet, withFX = withFX, style = NA, sheetSource = NA)
  }
  
  writeValues <- function(sheet, rowMin, rowMax, colMin, colMax, isNumeric){
    style <- ifelse(isNumeric, "numContent", "textContent")
    data.table(content = "writeValues", row1 = rowMin, row2 = rowMax, col1 = colMin, col2 = colMax, textValue = "", numericValue = "", sheet = sheet, withFX = NA, style = style, sheetSource = NA)
  }
  
  addBaseFont <- function(sheet, font, fontsize){
    data.table(content = "addBaseFont", row1 = 0, row2 = NA, col1 = 0, col2 = NA, textValue = font, numericValue = as.character(fontsize), sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
  }
  
  addStyle <- function(sheet, style, rowMin, rowMax, colMin, colMax, stack){
    stack <- ifelse(stack, 1, 0)
    data.table(content = "addStyle", row1 = rowMin, row2 = rowMax, col1 = colMin, col2 = colMax, textValue = "", numericValue = "", sheet = sheet, withFX = stack, style = style, sheetSource = NA)
  }
  
  addColWidth <- function(sheet, col, width){
    data.table(content = "addColWidth", row1 = 0, row2 = NA, col1 = col, col2 = NA, textValue = "", numericValue = width, sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
  }
  
  addFormat <- function(sheet, rowMin, rowMax, colMin, colMax, format){
    data.table(content = "addFormat", row1 = rowMin, row2 = rowMax, col1 = colMin, col2 = colMax, textValue = format, numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
  }
  
  rowsWithoutFX <- c(FDSValues[withFX == 0, row], FDSImport[withFX == 0, row])
  
  configFDS <- rbindlist(list(
    addCurrentVersion(),
    addWorksheet("Fundamental_Data", 300, 6),
    addText("Fundamental_Data", row = FDSLabel$row, col = FDSLabel$col, textValue = FDSLabel$field),
    addText("Fundamental_Data", row = rowsWithoutFX, col = 1, textValue = "x"),
    addNumericFromKeyword("Fundamental_Data", row = 14, col = 3, keyword = "FX_to_CHF", withFX = 0),
    addNumericFromKeyword("Fundamental_Data", row = FDSValues$row, col = 3, keyword = FDSValues$field, withFX = 0),
    addNumericFromKeyword("Fundamental_Data", row = FDSValues$row, col = 4, keyword = FDSValues$field, withFX = FDSValues$withFX),
    addNumericFromExcel(sheet = "Fundamental_Data", row = FDSImport$row, col = 3, sheetSource = FDSImport$sheet, rowSource = FDSImport$row1, colSource = FDSImport$col, withFX = 0),
    addNumericFromExcel(sheet = "Fundamental_Data", row = FDSImport$row, col = 4, sheetSource = FDSImport$sheet, rowSource = FDSImport$row1, colSource = FDSImport$col, withFX = FDSImport$withFX),
    addTextFromExcel(sheet = "Fundamental_Data", row = 9, col = 3, sheetSource = "Intro", rowSource = 9, colSource = 5),
    addTextFromExcel(sheet = "Fundamental_Data", row = 10, col = 3, sheetSource = "Intro", rowSource = 11, colSource = 5),
    addTextFromExcel(sheet = "Fundamental_Data", row = 5, col = 3, sheetSource = "RBC", rowSource = 5, colSource = 5),
    addTextFromExcel(sheet = "Fundamental_Data", row = 13, col = 3, sheetSource = "General Inputs", rowSource = 7, colSource = 4),
    writeValues("Fundamental_Data", rowMin = 1, rowMax = 227, colMin = 1, colMax = 6, isNumeric = FALSE),
    writeValues("Fundamental_Data", rowMin = 14, rowMax = 227, colMin = 3, colMax = 4, isNumeric = TRUE),
    addBaseFont("Fundamental_Data", font = "Arial", fontsize = 10),
    addStyle("Fundamental_Data", style = "commentStyle", rowMin = Styles$commentStyle$row1, rowMax = Styles$commentStyle$row2, colMin = 6, colMax = 6, stack = 0),
    addStyle("Fundamental_Data", style = "headerStyle", rowMin = c(8, 12), rowMax = c(8, 12), colMin = 2, colMax = 3, stack = 0),
    addStyle("Fundamental_Data", style = "headerStyle", rowMin = Styles$headerStyle$row1, rowMax = Styles$headerStyle$row1, colMin = 2, colMax = 4, stack = 0),
    addStyle("Fundamental_Data", style = "headerStyleCentering", rowMin = 5, rowMax = 5, colMin = c(2, 6), colMax = c(4, 6), stack = 0),
    addStyle("Fundamental_Data", style = "topHeaderStyle", rowMin = 1, rowMax = 1, colMin = 2, colMax = 2, stack = 0),
    addStyle("Fundamental_Data", style = "boldStyle", rowMin = Styles$boldStyle$row1, rowMax = Styles$boldStyle$row1, colMin = 2, colMax = 2, stack = 0),
    addStyle("Fundamental_Data", style = "whiteStyle", rowMin = rowsWithoutFX, rowMax = rowsWithoutFX, colMin = 1, colMax = 1, stack = 0),
    addStyle("Fundamental_Data", style = "italicStyle", rowMin = Styles$italicStyle$row1, rowMax = Styles$italicStyle$row1, colMin = 2, colMax = 2, stack = 0),
    addStyle("Fundamental_Data", style = "lightGridStyle", rowMin = c(9, 13), rowMax = c(10, 14), colMin = 2, colMax = 3, stack = 1),
    addStyle("Fundamental_Data", style = "lightGridStyle", rowMin = Styles$lightGridStyle$row1, rowMax = Styles$lightGridStyle$row2, colMin = 2, colMax = 4, stack = 1),
    addStyle("Fundamental_Data", style = "whiteGridStyle", rowMin = 16, rowMax = 16, colMin = 2, colMax = 4, stack = 1),
    addColWidth("Fundamental_Data", col = 1:6, width = c("7.64", "95.18", "25.18", "25.18", "3.82", "54.55")),
    addFormat("Fundamental_Data", rowMin = 1, rowMax = 227, colMin = 3, colMax = 4, format = "0.0"),
    addFormat("Fundamental_Data", rowMin = 113, rowMax = 113, colMin = 3, colMax = 4, format = "0%")
  ))
  
  fwrite(configFDS, "inst/extdata/wbFDS.csv")
}